#include <c_ext.h>

static uchar code dp4x18[] =
 { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0xF0,0xF0,0xF0,0xF0 };


uchar code * bm15x18 (uchar ch)
/**************************************************************/
/* return a pointer to bit matrix representing the character  */
/* ch into a font 15 x 18 pixel       						  */
/**************************************************************/
{
 code struct _ch15x18 { uchar ch; uchar bm[54]; } ch15x18[] =
  {
   ' ',
        0,    0,    0,
        0,    0,    0, 
        0,    0,    0,
        0,    0,    0,  
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
   '.',
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,   
        0,    0,    0,
        0,    0xF0, 0,
        0,    0xF0, 0,
        0,    0xF0, 0,
        0,    0xF0, 0,
   '-',
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
        0x7F, 0xFC, 0,
        0x7F, 0xFC, 0,
        0x7F, 0xFC, 0,
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
   '+',
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
        0x03, 0x80, 0,
        0x03, 0x80, 0,
        0x03, 0x80, 0,
        0x03, 0x80, 0,
        0x7F, 0xFC, 0,
        0x7F, 0xFC, 0,
        0x7F, 0xFC, 0,
        0x03, 0x80, 0,
        0x03, 0x80, 0,
        0x03, 0x80, 0,
        0x03, 0x80, 0,
        0,    0,    0,
        0,    0,    0,
        0,    0,    0,
   '1',
        0,    0xE0, 0,
        0x01, 0xE0, 0,
        0x03, 0xE0, 0,
        0x07, 0xE0, 0,
        0x0E, 0xE0, 0,
        0x1C, 0xE0, 0,
        0,    0xE0, 0,
        0,    0xE0, 0,
        0,    0xE0, 0,
        0,    0xE0, 0,
        0,    0xE0, 0,
        0,    0xE0, 0,
        0,    0xE0, 0,
        0,    0xE0, 0,
        0,    0xE0, 0,
        0x07, 0xFC, 0,
        0x07, 0xFC, 0,
        0x07, 0xFC, 0,
   '2',
        0x1F, 0xF0, 0,
        0x3F, 0xF8, 0,
        0x7F, 0xFC, 0,
        0xF0, 0x1E, 0,
        0xE0, 0x0E, 0,
        0xE0, 0x0E, 0,
        0,    0x1E, 0,
        0,    0x3C, 0,
        0,    0xF8, 0,
        0x01, 0xF0, 0,
        0x07, 0xC0, 0,
        0x1F, 0,    0,
        0x3C, 0,    0,
        0x78, 0,    0,
        0xF0, 0,    0,
        0xFF, 0xFE, 0,
        0xFF, 0xFE, 0,
        0xFF, 0xFE, 0,
   '3',
        0xFF, 0xFE, 0,
        0xFF, 0xFC, 0,
        0xFF, 0xF8, 0,
        0,    0x70, 0,
        0,    0xE0, 0,
        0x01, 0xC0, 0,
        0x03, 0xC0, 0,
        0x07, 0xF0, 0,
        0x07, 0xF8, 0,
        0,    0x3C, 0,
        0,    0x1E, 0,
        0,    0x0E, 0,
        0,    0x0E, 0,
        0xE0, 0x0E, 0,
        0xF0, 0x1E, 0,
        0x7F, 0xFC, 0,
        0x3F, 0xF8, 0,
        0x1F, 0xF0, 0,

   '4',
        0,    0xF0, 0,
        0x01, 0xF0, 0,
        0x03, 0xF0, 0,
        0x07, 0xF0, 0,
        0x0F, 0x70, 0,
        0x1E, 0x70, 0,
        0x3C, 0x70, 0,
        0x78, 0x70, 0,
        0xF0, 0x70, 0,
        0xE0, 0x70, 0,
        0xFF, 0xFE, 0,
        0xFF, 0xFE, 0,
        0xFF, 0xFE, 0,
        0,    0x70, 0,
        0,    0x70, 0,
        0,    0x70, 0,
        0,    0x70, 0,
        0,    0x70, 0,
   '5',
        0xFF, 0xFE, 0,
        0xFF, 0xFE, 0,
        0xFF, 0xFE, 0,
        0xE0, 0,    0,
        0xE0, 0,    0,
        0xE0, 0,    0,
        0xE0, 0,    0,
        0xFF, 0xF0, 0,
        0xFF, 0xF8, 0,
        0xFF, 0xFC, 0,
        0,    0x1E, 0,
        0,    0x0E, 0,
        0,    0x0E, 0,
        0xE0, 0x0E, 0,
        0xF0, 0x1E, 0,
        0x7F, 0xFC, 0,
        0x3F, 0xF8, 0,
        0x1F, 0xF0, 0,
   '6',
        0x0F, 0xF0, 0,
        0x1F, 0xF0, 0,
        0x3F, 0xF0, 0,
        0x78, 0,    0,
        0xF0, 0,    0,
        0xE0, 0,    0,
        0xE0, 0,    0,
        0xFF, 0xF0, 0,
        0xFF, 0xF8, 0,
        0xFF, 0xFC, 0,
        0xF0, 0x1E, 0,
        0xE0, 0x0E, 0,
        0xE0, 0x0E, 0,
        0xE0, 0x0E, 0,
        0xF0, 0x1E, 0,
        0x7F, 0xFC, 0,
        0x3F, 0xF8, 0,
        0x1F, 0xF0, 0,
   '7',
        0xFF, 0xFE, 0,
        0xFF, 0xFE, 0,
        0xFF, 0xFE, 0,
        0,    0x0E, 0,
        0,    0x1E, 0,
        0,    0x3C, 0,
        0,    0x78, 0,
        0,    0xF0, 0,
        0x01, 0xE0, 0,
        0x03, 0xC0, 0,
        0x07, 0x80, 0,
        0x0F, 0,    0,
        0x0E, 0,    0,
        0x0E, 0,    0,
        0x0E, 0,    0,
        0x0E, 0,    0,
        0x0E, 0,    0,
        0x0E, 0,    0,
   '8',
        0x1F, 0xF0, 0,
        0x3F, 0xF8, 0,
        0x7F, 0xFC, 0,
        0xF0, 0x1E, 0,
        0xE0, 0x0E, 0,
        0xE0, 0x0E, 0,
        0xF0, 0x1E, 0,
        0x7F, 0xFC, 0,
        0x3F, 0xF8, 0,
        0x7F, 0xFC, 0,
        0xF0, 0x1E, 0,
        0xE0, 0x0E, 0,
        0xE0, 0x0E, 0,
        0xE0, 0x0E, 0,
        0xF0, 0x1E, 0,
        0x7F, 0xFC, 0,
        0x3F, 0xF8, 0,
        0x1F, 0xF0, 0,
   '9',
        0x1F, 0xF0, 0,
        0x3F, 0xF8, 0,
        0x7F, 0xFC, 0,
        0xF0, 0x1E, 0,
        0xE0, 0x0E, 0,
        0xE0, 0x0E, 0,
        0xE0, 0x0E, 0,
        0xF0, 0x1E, 0,
        0x7F, 0xFE, 0,
        0x3F, 0xFE, 0,
        0x1F, 0xFE, 0,
        0,    0x0E, 0,
        0,    0x0E, 0,
        0,    0x1E, 0,
        0,    0x3C, 0,
        0x1F, 0xF8, 0,
        0x1F, 0xF0, 0,
        0x1F, 0xE0, 0,
   '0',
        0x1F, 0xF0, 0,
        0x3F, 0xF8, 0,
        0x7F, 0xFC, 0,
        0xF0, 0x1E, 0,
        0xE0, 0x0E, 0,
        0xE0, 0x0E, 0,
        0xE0, 0x0E, 0,
        0xE0, 0x0E, 0,
        0xE0, 0x0E, 0,
        0xE0, 0x0E, 0,
        0xE0, 0x0E, 0,
        0xE0, 0x0E, 0,
        0xE0, 0x0E, 0,
        0xE0, 0x0E, 0,
        0xF0, 0x1E, 0,
        0x7F, 0xFC, 0,
        0x3F, 0xF8, 0,
        0x1F, 0xF0, 0
  };
 uchar i = sizeof(ch15x18) / sizeof(struct _ch15x18);
 if (ch == '.') return dp4x18;
 while ((--i) && (ch15x18[i].ch != ch));
 return ch15x18[i].bm;
}
